//++
//
// ms_centre main module (SEModuleMain.cpp)
//
//  2005, Nick Morgalla
// MorSoft / MorSynth
// June 2005
// V1.1
//
// Using SynthEdit SDK V2.180
// Based on examples provided by:
//  2002, Jeff M Soft und Hardware GmbH, All Rights Reserved
//
//--

#include "Module.h"
#include "GuiModule.h"
#include "SEMod_struct.h"

extern "C" {
__declspec (dllexport)
int getModuleProperties(int p_index, SEModuleProperties* p_properties)
{
	p_properties->sdk_version = SDK_VERSION;

	switch( p_index )							
	{
	case 0:
		Module::getModuleProperties(p_properties);
		break;
	default:
		return false;
	};

	return true;
}
}

extern "C" {
__declspec (dllexport)
void * makeModule(int p_index, int p_type, seaudioMasterCallback2 seaudioMaster, void *p_resvd1)
{
	switch( p_index )
	{
	case 0:
		{
			if (p_type == 1)								// Audio Processing Object
			{
				SEModule_base *effect = new Module(seaudioMaster, p_resvd1);
				
				if (!effect) return 0;

				return effect->getAeffect();
			}

			if (p_type == 2)								// GUI Object
			{
				GuiModule *effect = new GuiModule((seGuiCallback) seaudioMaster, p_resvd1); //nasty!
				
				if (!effect) return 0;

				return effect->getAeffect();
			}
		}
		break;
	};

	return 0;
}
}

#if WIN32
#include <windows.h>
void* hInstance;
BOOL WINAPI DllMain (HINSTANCE hInst, DWORD dwReason, LPVOID lpvReserved)
{
	hInstance = hInst;
	return 1;
}
#endif
